/* ATB_Anz4_Prg_1.c Created: 25.05.2015 09:04:43 Author: AS */ 
/* alle Rechte by achim seeger unter GPL myroboter@web.de, wnsche viel Spass damit */

#define F_CPU 16000000				// CPU clock in Hz
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include "HT16K33.h"
#include "i2cmaster.h"      		// Aufruf twimaster
#include "util/delay.h"

// P30, NT2, P81 mit 2 Balkenanzeige mit HT16K33 (links rechts)

int main (void)
  {
	i2c_init();							// Address 0x70 ..0x73)
	HT16K33_modul1_addr = 0x70;
	HT16K33_modul2_addr = 0x71;
	HT16K33_Init1();
	HT16K33_Init2();
	while(1)
	  {
		_delay_ms(2000);				// Pause
		// 0, 1 - 1. Gruppe beide Segment
		// 2, 3 - 2. Gruppe beide Segment
		// 4, 5 - 3. Gruppe beide Segment
		// 0, 2, 4 - rote LED, beide Segment
		// 1, 3, 5 - grne LED, beide Segmente
		// 0x07 - Zahl rechts - linkes Segment
		// 0x70 - Zahl links - rechtes Segment
		// 0x77 - beide Zahlen, beide Segmente	
			
		////////////////////////////////////////////
		// untere Balkenanzeige, Anzeige links, IC rechts, Anfang links
		// obere Balkenanzeige, Anzeige rechts, IC links, Anfang rechts
		
		HT16K33_ClearDisplay1(0);			// lscht Rot beide unten
		HT16K33_ClearDisplay1(1);			// lscht Grn beide unten
		HT16K33_ClearDisplay2(0);			// lscht Rot beide oben
		HT16K33_ClearDisplay2(1);			// lscht Grn beide oben
		
		////////////// Step 1
		_delay_ms(2000);
		
		// linkes Segment, Gruppe 2, Farbe grn an unten
		HT16K33_WriteDisplay1(3,0x0f);		// fllt Balken unten
		
		// linkes Segment, Gruppe 1, Farbe rot an unten
		HT16K33_WriteDisplay2(0,0x0f);		// fllt Balken unten
		
		// linkes Segment, Gruppe 3, Farbe orange da rot und grn an unten
		HT16K33_WriteDisplay1(4,0x0f);		// fllt Balken unten
		HT16K33_WriteDisplay2(5,0x0f);		// fllt Balken	unten
		
		// linkes Segment, Gruppe 2, Farbe grn an oben
		HT16K33_WriteDisplay5(3,0x0f);		// fllt Balken oben
		
		// linkes Segment, Gruppe 1, Farbe rot an oben
		HT16K33_WriteDisplay6(0,0x0f);		// fllt Balken oben
		
		// linkes Segment, Gruppe 3, Farbe orange da rot und grn an oben
		HT16K33_WriteDisplay5(4,0x0f);		// fllt Balken oben
		HT16K33_WriteDisplay6(5,0x0f);		// fllt Balken	oben
		
		_delay_ms(2000);
		HT16K33_ClearDisplay1(0);			// lscht Rot beide unten
		HT16K33_ClearDisplay1(1);			// lscht Grn beide unten
		HT16K33_ClearDisplay2(0);			// lscht Rot beide oben
		HT16K33_ClearDisplay2(1);			// lscht Grn beide oben
			
		//////////// Step 2
		
		// rechtes Segment, Gruppe 1, Farbe rot an unten
		HT16K33_WriteDisplay3(0,0xf0);		// fllt Balken unten
		
		// rechtes Segment, Gruppe 2, Farbe grn an unten
		HT16K33_WriteDisplay4(3,0xf0);		// fllt Balken unten
		
		// rechtes Segment, Gruppe 3, Farbe orange da rot und grn an unten
		HT16K33_WriteDisplay3(4,0xf0);		// fllt Balken unten
		HT16K33_WriteDisplay4(5,0xf0);		// fllt Balken unten
		
		// rechtes Segment, Gruppe 1, Farbe rot an oben
		HT16K33_WriteDisplay7(0,0xf0);		// fllt Balken oben
		
		// rechtes Segment, Gruppe 2, Farbe grn an oben
		HT16K33_WriteDisplay8(3,0xf0);		// fllt Balken oben
		
		// rechtes Segment, Gruppe 3, Farbe orange da rot und grn an oben
		HT16K33_WriteDisplay7(4,0xf0);		// fllt Balken oben
		HT16K33_WriteDisplay8(5,0xf0);		// fllt Balken oben
		
		_delay_ms(2000);
		HT16K33_ClearDisplay1(0);			// lscht Rot beide unten
		HT16K33_ClearDisplay1(1);			// lscht Grn beide unten
		HT16K33_ClearDisplay2(0);			// lscht Rot beide oben
		HT16K33_ClearDisplay2(1);			// lscht Grn beide oben
		
		/////////////// Step 3
		
		// beide Segment, Gruppe 1, Farbe rot an unten
		HT16K33_WriteDisplay3(2,0xff);		// fllt Matrix unten
		
		// beide Segment, Gruppe 2, Farbe grn an unten
		HT16K33_WriteDisplay4(5,0xff);		// fllt Balken unten
		
		// beide Segment, Gruppe 3, Farbe orange da rot und grn an unten
		HT16K33_WriteDisplay3(0,0xff);		// fllt Balken unten
		HT16K33_WriteDisplay4(1,0xff);		// fllt Balken unten
		
		// beide Segment, Gruppe 1, Farbe rot an oben
		HT16K33_WriteDisplay7(2,0xff);		// fllt Balken oben
		
		// beide Segment, Gruppe 2, Farbe grn an oben
		HT16K33_WriteDisplay8(5,0xff);		// fllt Balken oben
		
		// beide Segment, Gruppe 3, Farbe orange da rot und grn an oben
		HT16K33_WriteDisplay7(0,0xff);		// fllt Balken oben
		HT16K33_WriteDisplay8(1,0xff);		// fllt Balken oben
		
		_delay_ms(2000);				// Pause
	  }
	return 0;							// by AS
  }